﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Components;
using UserService.DatabaseLayer.DataModels;
using UserService.DatabaseLayer.Repository;

namespace UserService.Pages
{
    public class DirectoryBase : ComponentBase
    {
        private Node? _selectedNode;
        public IReadOnlyList<Node>? OrganizationUnits { get; set; }

        public Node? SelectedNode
        {
            get => _selectedNode;
            set
            {
                if(Equals(_selectedNode, value)) return;
                _selectedNode = value;
                OnSelectedNodeChanged(value);
            }
        }

        private async void OnSelectedNodeChanged(Node? value)
        {
            Members = await UsersRepository.GetAllAsync();
        }

        [Inject] public IOrganizationUnitsRepository OuRepository { get; set; }

        [Inject] public IUsersRepository UsersRepository { get; set; }


        protected override async Task OnInitializedAsync()
        {
            OrganizationUnits = (await OuRepository.GetAllAsync().ConfigureAwait(false))
                .Where(x => x.Parent is null)
                .ToList();
        }

    }
}